Subject: [kvm-unit-tests PATCH v5 00/29] powerpc: updates, P10, PNV support

From: Nicholas Piggin <[email-masked]>
Date: Sat, 16 Dec 2023 23:42:27 +1000

This has taken quite a while to get right, but I think is getting
much better now.

There are several semi-related things here: multi-migration support,
bugfixing, adding powernv machine, expanding and adding test cases.
But I found it easiest to leave it as one series. Multi-migration I
added when testing and debugging time migration issues in QEMU, and
that has grown to quite a size, I can try to split that out if
preferred.

Since v4:
- Multi migration now seems quite solid, I haven't broken it. Arm64
  migration regression reported by Shaoqin is fixed, it was due to an exit
  status getting lost.
- Several other small migration fixes and cleanups that poppedup in
  testing.
- More complete SMP support including IPI for pseries and powernv.
- Made powernv a first-class citizen that can do run_tests.sh unit
  tests (with machine option).
- More polished, quiet warnings, skip unsupported tests, etc.
- Fix several powerpc bugs that got exposed (.got, stack backtrace,
  stack alignment).
- Added a bunch more tests I've been accumulating, atomics, smp,
  timebase, interrupts.

Note the arm64 psci cpu-on test is flakey with/without this series.

Thanks,
Nick

Nicholas Piggin (29):
  arch-run: Clean up temporary files properly
  arch-run: Clean up initrd cleanup
  migration: use a more robust way to wait for background job
  migration: Support multiple migrations
  arch-run: rename migration variables
  powerpc: Quiet QEMU TCG pseries capability warnings
  powerpc: Add a migration stress tester
  powerpc: Require KVM for the TM test
  powerpc: Fix interrupt stack alignment
  powerpc/sprs: Specify SPRs with data rather than code
  powerpc/sprs: Don't fail changed SPRs that are used by the test
    harness
  powerpc/sprs: Avoid taking async interrupts caused by register fuzzing
  powerpc: Make interrupt handler error more readable
  powerpc: Expand exception handler vector granularity
  powerpc: Add support for more interrupts including HV interrupts
  powerpc: Set .got section alignment to 256 bytes
  powerpc: Discover runtime load address dynamically
  powerpc: Fix stack backtrace termination
  scripts: allow machine option to be specified in unittests.cfg
  scripts: Accommodate powerpc powernv machine differences
  powerpc: Support powernv machine with QEMU TCG
  powerpc: Fix emulator illegal instruction test for powernv
  powerpc/sprs: Test hypervisor registers on powernv machine
  powerpc: interrupt tests
  powerpc: Add rtas stop-self support
  powerpc: add SMP and IPI support
  powerpc: Avoid using larx/stcx. in spinlocks when only one CPU is
    running
  powerpc: Add atomics tests
  powerpc: Add timebase tests

 lib/migrate.c               |   8 +-
 lib/migrate.h               |   1 +
 lib/powerpc/asm/ppc_asm.h   |  25 ++
 lib/powerpc/asm/processor.h |  41 +++
 lib/powerpc/asm/rtas.h      |   2 +
 lib/powerpc/asm/setup.h     |   3 +-
 lib/powerpc/asm/smp.h       |  24 +-
 lib/powerpc/hcall.c         |   4 +-
 lib/powerpc/io.c            |  27 +-
 lib/powerpc/io.h            |   6 +
 lib/powerpc/processor.c     |  55 ++-
 lib/powerpc/rtas.c          |  78 ++++-
 lib/powerpc/setup.c         |  50 ++-
 lib/powerpc/smp.c           | 270 +++++++++++++--
 lib/powerpc/spinlock.c      |  28 ++
 lib/ppc64/asm/atomic.h      |   6 +
 lib/ppc64/asm/opal.h        |  20 ++
 lib/ppc64/asm/ptrace.h      |   1 +
 lib/ppc64/asm/spinlock.h    |   7 +-
 lib/ppc64/opal-calls.S      |  46 +++
 lib/ppc64/opal.c            |  76 +++++
 powerpc/Makefile.common     |   8 +-
 powerpc/Makefile.ppc64      |   2 +
 powerpc/atomics.c           | 190 +++++++++++
 powerpc/cstart64.S          | 163 +++++++--
 powerpc/emulator.c          |  19 +-
 powerpc/flat.lds            |   3 +-
 powerpc/interrupts.c        | 412 +++++++++++++++++++++++
 powerpc/migrate.c           |  64 ++++
 powerpc/run                 |  39 ++-
 powerpc/smp.c               | 199 +++++++++++
 powerpc/sprs.c              | 642 +++++++++++++++++++++++++-----------
 powerpc/timebase.c          | 328 ++++++++++++++++++
 powerpc/tm.c                |   2 +-
 powerpc/unittests.cfg       |  37 +++
 scripts/arch-run.bash       | 181 +++++++---
 scripts/common.bash         |   8 +-
 scripts/runtime.bash        |  20 +-
 38 files changed, 2736 insertions(+), 359 deletions(-)
 create mode 100644 lib/powerpc/spinlock.c
 create mode 100644 lib/ppc64/asm/atomic.h
 create mode 100644 lib/ppc64/asm/opal.h
 create mode 100644 lib/ppc64/opal-calls.S
 create mode 100644 lib/ppc64/opal.c
 create mode 100644 powerpc/atomics.c
 create mode 100644 powerpc/interrupts.c
 create mode 100644 powerpc/migrate.c
 create mode 100644 powerpc/smp.c
 create mode 100644 powerpc/timebase.c

-- 
2.42.0